'EX93.EXE
'Cash Register Application
'SJJ Embedded Micro Solutions
'www.sjjmicro.com / www.seanliming.com
'Copyright (c) 2006 SJJ Embedded Micro Solutions    All Rights Reserved
'
'Source code is provided as is without any warranty. Any errors or omissions shall not imply any 
'liability for direct or indirect consequences arising from the use of this source code. The authors
'and reviewers make no warranty for the correctness or for the use of this source code, and asseme no
'liability for direct or indirect damages of any kind arising from the use of this source code.
'
'The author resrves the right to make changes in this source code without notice and without
'incurring any liability.
'
'Cash - WEPOS Sample Cash Register Application
'
'Date: 7/10/06 - Comments generated
'
'
'
Imports Microsoft.PointOfService
Imports System.Text


Public Class Form1

    WithEvents explorer As PosExplorer
    WithEvents myScanner As Scanner
    WithEvents myMSR As Msr
    Dim myDisplay As LineDisplay
    Dim myPrinter As PosPrinter
    Dim myCashDrawer As CashDrawer

    Dim SaleTotal As Decimal

    Public Sub New()

        ' This call is required by the Windows Form Designer.
        InitializeComponent()

        ' Add any initialization after the InitializeComponent() call.
        explorer = New PosExplorer(Me)


        'Call Subroutine to initialize the POS devices
        InitializeDevices()



    End Sub

    Private Sub btnEnter_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnEnter.Click
        Update()
        myDisplay.ClearText()

        Dim myItem As String = txtItemInput.Text


        'Use a database - and you will need to change the view for payment options

        'If myItem = "9780929392776" Then
        'lstITEMS.Items.Add(myItem & " Windows XP Embedded Advanced by Sean Liming  $39.99")
        'display.DisplayText(myItem & " XPE Advanced $39.99")
        'SaleTotal = SaleTotal + 39.99
        'ElseIf myItem = "9781932373967" Then
        'lstITEMS.Items.Add(myItem & " XP Embedded Supplemental Toolkit by Sean Liming  $34.99")
        'display.DisplayText(myItem & " XPE Toolkit $34.99")
        'SaleTotal = SaleTotal + 34.99
        'Else
        'lstITEMS.Items.Add(myItem)
        'display.DisplayText(myItem)
        'End If

        txtItemInput.Clear()
        txtTotal.Text = SaleTotal
        lblStatus.Text = "Item added"
        Update()


    End Sub

    Private Sub txtItemInput_KeyPress(ByVal sender As Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtItemInput.KeyPress

        'Adds item to sale with an Enter press either by Scanner or keyboard
        If e.KeyChar = Chr(13) Then
            Me.btnEnter.PerformClick()
        End If

    End Sub

    Private Sub btnCancelSale_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnCancelSale.Click
        lstITEMS.Items.Clear()
        myDisplay.ClearText()
        myDisplay.DisplayText("Sale cancelled")
        txtTotal.Text = 0.0
        lblStatus.Text = "Sale cancelled"
        Update()
    End Sub


    Private Sub btnKEYBOARD_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnKEYBOARD.Click
        Process.Start("osk.exe")
    End Sub


#Region "Numeric Buttons"

    Private Sub btnNum1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum1.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "1"
        txtItemInput.Text = tempValue
        Update()
    End Sub

    Private Sub btnNum2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum2.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "2"
        txtItemInput.Text = tempValue
        Update()
    End Sub

    Private Sub btnNum3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum3.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "3"
        txtItemInput.Text = tempValue
        Update()
    End Sub

    Private Sub btnNum4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum4.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "4"
        txtItemInput.Text = tempValue
        Update()
    End Sub

    Private Sub btnNum5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum5.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "5"
        txtItemInput.Text = tempValue
        Update()
    End Sub

    Private Sub btnNum6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum6.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "6"
        txtItemInput.Text = tempValue
        Update()
    End Sub
    Private Sub btnNum7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum7.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "7"
        txtItemInput.Text = tempValue
        Update()
    End Sub

    Private Sub btnNum8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum8.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "8"
        txtItemInput.Text = tempValue
        Update()
    End Sub

    Private Sub btnNum9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum9.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "9"
        txtItemInput.Text = tempValue
        Update()
    End Sub
    Private Sub btnNum0_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNum0.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "0"
        txtItemInput.Text = tempValue
        Update()
    End Sub

    Private Sub btnNumDot_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNumDot.Click
        Dim tempValue As String
        Update()
        tempValue = txtItemInput.Text
        tempValue = tempValue & "."
        txtItemInput.Text = tempValue
        Update()
    End Sub
#End Region 'Numeric Buttons


    Private Sub btnClear_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnClear.Click
        'Clear the Input
        txtItemInput.Clear()
    End Sub

    Private Sub cmdRemove_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdRemove.Click
        Dim ListItemIndex As Integer
        Update()
        myDisplay.ClearText()
        ListItemIndex = lstITEMS.SelectedIndex()

        'Got to figure out how to get database to work here
        If ListItemIndex >= 0 Then
            If lstITEMS.SelectedItem = "9780929392776 Windows XP Embedded Advanced by Sean Liming  $39.99" Then
                myDisplay.DisplayText("Removing XPE Advanced $39.99")
                SaleTotal = SaleTotal - 39.99
            ElseIf lstITEMS.SelectedItem = "9781932373967 XP Embedded Supplemental Toolkit by Sean Liming  $34.99" Then
                myDisplay.DisplayText("Removing XPE Toolkit $34.99")
                SaleTotal = SaleTotal - 34.99
            Else
                myDisplay.DisplayText("Item removed")
            End If
            lstITEMS.Items.RemoveAt(ListItemIndex)
        End If

        'Update the total Sale
        txtTotal.Text = SaleTotal
        lblStatus.Text = "Item removed"
        Update()


    End Sub

    Private Sub btnBack_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnBack.Click
        Dim tempItem As String
        Dim tempItemIndex As Integer
        Update()
        tempItem = txtItemInput.Text
        tempItemIndex = tempItem.Length

        If tempItemIndex > 0 Then
            txtItemInput.Text = tempItem.Substring(0, tempItemIndex - 1)
            Update()
        End If

    End Sub

    '******************************************************************************************************************
    '
    'explorer_DeviceAddedEvent
    'explorer was defined WithEvents at the top of the listing. This enables two events DeviceAddedEvent and DeviceRemoveEvent
    'Here we will check to see what devices were added and display to the line display
    '
    'Make sure the WASP WCS3905 scanner.xml files is in the \Program Files\Common Files\Microsoft Shared\Point Of Service\Control Configurations directory
    '
    Private Sub explorer_DeviceAddedEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceChangedEventArgs) Handles explorer.DeviceAddedEvent
        If (e.Device.Type = "Scanner") Then
            myScanner = explorer.CreateInstance(e.Device)
            myDisplay.ClearText()
            myDisplay.DisplayText("New bar-code scanner attached")
            lblStatus.Text = "New bar-code scanner attached: " & e.Device.ServiceObjectName
            myScanner.Open()
            myScanner.Claim(1000)
            myScanner.DeviceEnabled = True
            myScanner.DataEventEnabled = True
            myScanner.DecodeData = True
            Update()
        End If

        If (e.Device.Type = "Msr") Then
            myMSR = explorer.CreateInstance(e.Device)
            myDisplay.ClearText()
            myDisplay.DisplayText("New bar-code scanner attached")
            lblStatus.Text = "New Msr attached: " & e.Device.ServiceObjectName
            myMSR.Open()
            myMSR.Claim(1000)
            myMSR.DeviceEnabled = True
            myMSR.DataEventEnabled = True
            myMSR.DecodeData = True
            Update()
        End If

    End Sub

    '******************************************************************************************************************
    '
    'explorer_DeviceRemoveEvent
    'explorer was defined WithEvents at the top of the listing. This enables two events DeviceAddedEvent and DeviceRemoveEvent
    'Here we will check to see what devices were removed added and display to the line display
    '
    '
    Private Sub explorer_DeviceRemovedEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DeviceChangedEventArgs) Handles explorer.DeviceRemovedEvent
        If (e.Device.Type = "Scanner") Then
            myDisplay.ClearText()
            myDisplay.DisplayText("Bar-code scanner removed")
            lblStatus.Text = "Bar-code scanner removed"
            myScanner.DecodeData = False
            myScanner.DataEventEnabled = False
            myScanner.DeviceEnabled = False
            myScanner.Release()
            myScanner.Close()
            Update()
        End If

        If (e.Device.Type = "Msr") Then
            myDisplay.ClearText()
            myDisplay.DisplayText("Msr removed")
            lblStatus.Text = "Msr removed"
            myMSR.DataEventEnabled = False
            myMSR.DecodeData = False
            myMSR.Release()
            myMSR.Close()
            lblStatus.Text = "Msr Detached"
            Update()
        End If


    End Sub

    Private Sub MyScanner_DataEvent(ByVal sender As Object, ByVal e As Microsoft.PointOfService.DataEventArgs) Handles myScanner.DataEvent

        Dim myEncoding As New ASCIIEncoding

        myDisplay.ClearText()
        'display.DisplayText(myEncoding.GetString(Scanner1.ScanDataLabel))

        Dim myItem As String = myEncoding.GetString(myScanner.ScanDataLabel)

        If myItem = "97809293" Then
            lstITEMS.Items.Add(myItem & " Windows XP Embedded Advanced by Sean Liming  $39.99")
            myDisplay.DisplayText(myItem & " XPE Advanced $39.99")
            SaleTotal = SaleTotal + 39.99
        ElseIf myItem = "97819323" Then
            lstITEMS.Items.Add(myItem & " XP Embedded Supplemental Toolkit by Sean Liming  $34.99")
            myDisplay.DisplayText(myItem & " XPE Toolkit $34.99")
            SaleTotal = SaleTotal + 34.99
        Else
            lstITEMS.Items.Add(myItem)
            myDisplay.DisplayText(myItem)
        End If

        txtItemInput.Clear()
        txtTotal.Text = SaleTotal
        lblStatus.Text = "Item added"
        Update()

        myScanner.DataEventEnabled = True
    End Sub

   
    Private Sub InitializeDevices()



        'Poll Display setup
        'If the display is not attached it cannot be claimed. An exception will pop
        'if we don't have the try-catch in place
        Try
            Dim device As DeviceInfo = explorer.GetDevice("LineDisplay", "WPD220")
            myDisplay = explorer.CreateInstance(device)
            myDisplay.Open()
            myDisplay.Claim(1000)
            myDisplay.DeviceEnabled = True
            myDisplay.ClearText()
            myDisplay.DisplayText("SJJ EMS              WEPOS/POS for .NET")
        Catch ex As Exception
            lblStatus.Text = "No LineDisplay Attached - Reconnect or Replace"

        End Try


        'Now lets get the Printer
        Try
            Dim device2 As DeviceInfo = explorer.GetDevice("PosPrinter", "WRP8500")
            myPrinter = explorer.CreateInstance(device2)
            myPrinter.Open()
            myPrinter.Claim(1000)
            myPrinter.AsyncMode = True
            myPrinter.DeviceEnabled = True
        Catch ex As Exception
            lblStatus.Text = "No Printer Attached - Reconnect or Replace"

        End Try

        'Get the Cash Drawer
        Try
            Dim device3 As DeviceInfo = explorer.GetDevice("CashDrawer", "WASPCD")
            myCashDrawer = explorer.CreateInstance(device3)
        Catch ex As Exception
            lblStatus.Text = "No Cash Drawer Attached - Reconnect or Replace"

        End Try

        'Connect the MSR
        Try
            Dim device4 As DeviceInfo = explorer.GetDevice("Msr", "myMSR")
            myMSR = explorer.CreateInstance(device4)
            myMSR.Open()
            myMSR.Claim(1000)
            myMSR.DeviceEnabled = True
            myMSR.DeviceEnabled = True
            myMSR.DataEventEnabled = True
            myMSR.DecodeData = True

        Catch ex As Exception
            lblStatus.Text = "No MSR Attached - Reconnect or Replace" '

        End Try

        'Finally, conenct the Bar Code Scanner
        Try
            Dim device5 As DeviceInfo = explorer.GetDevice("Scanner", "mySCanner")
            myScanner = explorer.CreateInstance(device5)
            myScanner.Open()
            myScanner.Claim(1000)
            myScanner.DeviceEnabled = True
            myScanner.DataEventEnabled = True
            myScanner.DecodeData = True

        Catch ex As Exception
            lblStatus.Text = "No SCanner Attached - Reconnect or Replace"

        End Try

        Update()

    End Sub



End Class
